// An array that holds complete information about all the 
// rectangles that have been drawn so far.  Each rectangle
// is stored as four consecutive integers in the array, so
// it'll look something like {x1,y1,w1,h1,x2,y2,w2,h2,...}
int[] perm_rects;

// TODO: You'll probably need some additional global variables
// here.

void setup()
{
  size( 500, 500 );
  
  // Start with no old rectangles, i.e., an array of size
  // zero.  That looks a bit weird, but it's legal.
  perm_rects = new int[ 0 ]; 
  
  // TODO -- initialize your global variables, if necessary.
}

void draw()
{
  background( 70 );
  
  // Walk through the array of saved rectangles four steps
  // at a time, drawing each of the rectangles in turn.
  for( int idx = 0; idx < perm_rects.length; idx += 4 ) {
    rect( perm_rects[idx], perm_rects[idx+1], 
      perm_rects[idx+2], perm_rects[idx+3] );
  }
  
  // TODO: If the user is currently dragging out a rectangle,
  // draw their rectangle here.
}

void mousePressed()
{
  // TODO: Start dragging a new rectangle
}

// A convenient helper function that abstracts the idea
// of adding the four integers defining a rectangle into the
// array of saved rectangles.  Do that using four calls to
// append, in the style of the sketch I posted in Piazza 
// and showed in class where you can click to add points to
// a path.
void saveRectangle( int x, int y, int w, int h )
{
  perm_rects = append( perm_rects, x );
  perm_rects = append( perm_rects, y );
  perm_rects = append( perm_rects, w );
  perm_rects = append( perm_rects, h );
}

void mouseReleased()
{
  // TODO: If the user was dragging a new rectangle, then
  // save that rectangle using the function above, and turn
  // off dragging.
}
